/* simplistic.l
 * Really simplistic lexer.
 */

%option noyywrap
%{
  #include <stdlib.h>
  #include <string.h>
  #include "shared.h"
  #define YYSTYPE shared

  #include "y.tab.h"
  #ifndef C
  #define C 263
  #endif
  #define YY_USER_ACTION { char *name = malloc(yyleng);\
                           yytext[yyleng-1] = 0;\
                           strcpy(name, yytext);\
                           yylval = token(name);\
                           ++yytokenpos; }


  char *name;
%}

noun  ("she"|"cat"|"home"|"neighbour"|"door"|"telescope")
verb  ("had"|"was"|"lived"|"saw"|"slept"|"liked")
det   ("a"|"the")
pro   ("next"|"at"|"with")
rel   ("that"|"which")
conj  (','|"and")

%%

{noun}[[:space:]] return N;
{verb}[[:space:]] return V;
{det}[[:space:]]  return D;
{pro}[[:space:]]  return P;
{rel}[[:space:]]  return R;
{conj}[[:space:]] return C;
.|\n   ;

%%
