/* shared.h
 * Shared forest nodes.
 */

#ifndef _SHARED_H
#define _SHARED_H

#include <stdlib.h>
#include <stdarg.h>
#include <stdio.h>

/** The current position in the input. */
unsigned short yytokenpos;

/** A shared node is a name along with its starting position and its length. */
typedef struct
{
  char*          nam;
  unsigned short pos;
  unsigned short len;
} shared;

/** Generates a shared token. */
shared token (char*);

/** Generates a shared node with its additional arguments as sons. */
shared shared_rule (char*, unsigned short, ...);

/** Prints a single shared node on the specified output. */
inline void print_shared (FILE*, shared);

/** Should we format for `dot' postprecessing? */
typedef enum { FALSE, TRUE } dot;
extern dot is_dot_format;

/** Prints a shared node production. */
void print_rule (shared, unsigned short,  ...);

#endif // !_SHARED_H
