/* ubda.y
 * Earley's UBDA pushed further...
 */

%glr-parser

%{
  #include "shared.h"
  #define YYSTYPE shared
  #define YYDEBUG 1
  #ifndef YYMAXDEPTH
  # define YYMAXDEPTH 100000
  #endif

  static int yylex (void);
  static char *yytext;
  int yydebug, yyprintmerges;
  static int yymax = 3;
  static void yyerror (char*);
  static shared merge (shared, shared);
%}


%token A

%%

s:
    A                           { $$ = shared_rule("s",1,$1);
                                  print_rule($$,1,$1); }
  | s s           %merge<merge> { $$ = shared_rule("s",2,$1,$2);
                                  print_rule($$,2,$1,$2); }
  | s s s         %merge<merge> { $$ = shared_rule("s",3,$1,$2,$3);
                                  print_rule($$,3,$1,$2,$3); }
  | s s s s       %merge<merge> { $$ = shared_rule("s",4,$1,$2,$3,$4);
                                  print_rule($$,4,$1,$2,$3,$4); }
  ;

%%
static int
yylex (void)
{
  yylval = token("a");
  return (yymax--)? A: 0;
}

static void
yyerror (char* msg)
{
  fprintf(stderr, "Error: %s before \"%s\".\n", msg, yytext);
}

static shared
merge (shared s0, shared s1)
{
  return s1;
}

int
main (int argc, char *argv[])
{
  int ret = 0;
  yytext = "a";
  yytokenpos = 0;
  yydebug = 1;

  if (argc == 2)
    yymax = atoi(argv[1]);

  if ((ret = yyparse()))
    fprintf (stderr, "Parsing failed.\n");

  return ret;
}
